// Class to read the turtle files and extract values from triples
class PodProfile {
  String profileRdfStr = '';

  PodProfile(String profileRdfStr){
    this.profileRdfStr = profileRdfStr;
  }

  List<dynamic> divideRdfData(String profileRdfStr){
    List<String> rdfDataList = [];
    String vcardPrefix = '';
    String foafPrefix = '';

    var profileDataList = profileRdfStr.split('\n');
    for (var i = 0; i < profileDataList.length; i++) {
      String dataItem = profileDataList[i];
      if (dataItem.contains(';')) {
        var itemList = dataItem.split(';');
        for (var j = 0; j < itemList.length; j++) {
          String item = itemList[j];
          rdfDataList.add(item);
        }
      }
      else{
        rdfDataList.add(dataItem);
      }

      if (dataItem.contains('<http://www.w3.org/2006/vcard/ns#>')) {
        var itemList = dataItem.split(' ');
        vcardPrefix = itemList[1];
      }

      if (dataItem.contains('<http://xmlns.com/foaf/0.1/>')) {
        var itemList = dataItem.split(' ');
        foafPrefix = itemList[1];
      }
    }
    return [rdfDataList, vcardPrefix, foafPrefix];
  }

  List<dynamic> dividePrvRdfData(){
    List<String> rdfDataList = [];
    final Map prefixList = {};

    var profileDataList = profileRdfStr.split('\n');
    for (var i = 0; i < profileDataList.length; i++) {
      String dataItem = profileDataList[i];
      if (dataItem.contains(';')) {
        var itemList = dataItem.split(';');
        for (var j = 0; j < itemList.length; j++) {
          String item = itemList[j];
          rdfDataList.add(item);
        }
      }
      else{
        rdfDataList.add(dataItem);
      }

      if (dataItem.contains('@prefix')) {
        var itemList = dataItem.split(' ');
        prefixList[itemList[1]] = itemList[2];
      }

    }
    return [rdfDataList, prefixList];
  }

  
  String getProfPicture(){
    var rdfRes = divideRdfData(profileRdfStr);
    List<String> rdfDataList = rdfRes[0];
    String vcardPrefix = rdfRes[1];
    String foafPrefix = rdfRes[2];
    String pictureUrl = '';
    String optionalPictureUrl = '';
    for (var i = 0; i < rdfDataList.length; i++) {
      String dataItem = rdfDataList[i];
      if (dataItem.contains(vcardPrefix+'hasPhoto')) {
        var itemList = dataItem.split('<');
        pictureUrl = itemList[1].replaceAll('>', '');
      }
      if(dataItem.contains(foafPrefix+'img')){
        var itemList = dataItem.split('<');
        optionalPictureUrl = itemList[1].replaceAll('>', '');
      }
    }
    if(pictureUrl.isEmpty & optionalPictureUrl.isNotEmpty){
      pictureUrl = optionalPictureUrl;
    }
    return pictureUrl;
  }
  
  String getProfName(){
    String profName = '';
    var rdfRes = divideRdfData(profileRdfStr);
    List<String> rdfDataList = rdfRes[0];
    String vcardPrefix = rdfRes[1];
    String foafPrefix = rdfRes[2];
    print(vcardPrefix);
    print(foafPrefix);
    for (var i = 0; i < rdfDataList.length; i++) {
      String dataItem = rdfDataList[i];
      if(dataItem.contains(vcardPrefix+'fn')){
        var itemList = dataItem.split('"');
        profName = itemList[1];
      }
    }
    if (profName.isEmpty) {
      profName = 'John Doe';
    }
    return profName;
  }

  String getPersonalInfo(String infoLabel){
    String personalInfo = '';
    var rdfRes = divideRdfData(profileRdfStr);
    List<String> rdfDataList = rdfRes[0];
    String vcardPrefix = rdfRes[1];
    for (var i = 0; i < rdfDataList.length; i++) {
      String dataItem = rdfDataList[i];
      if (dataItem.contains(vcardPrefix+infoLabel)) {
        var itemList = dataItem.split('"');
        personalInfo = itemList[1];
      }
    }
    return personalInfo;
  }

  String getAddressId(String infoLabel){
    String personalInfo = '';
    var rdfRes = divideRdfData(profileRdfStr);
    List<String> rdfDataList = rdfRes[0];
    String vcardPrefix = rdfRes[1];
    for (var i = 0; i < rdfDataList.length; i++) {
      String dataItem = rdfDataList[i];
      if (dataItem.contains(vcardPrefix+infoLabel)) {
        var itemList = dataItem.split(':');
        personalInfo = itemList[2];
      }
    }
    return personalInfo;
  }
}